#include "stdafx.h"
#include "mttermex.h"

using namespace XNSNET::Collections;
using namespace System;
using namespace System::Windows::Forms;
using namespace MetaTrader;
using namespace MetaTrader::Windows;

bool RetWindowException( Exception^ e ) {
	return ( (gcnew WindowException( e ))->ShowDialog( MainWindow::Current ) == DialogResult::Retry );
}

void ZeroString128( char* p ) {
	for( int i = 0; i < 16; i++ ) {
		((int*)p)[ i ] = 0x20202020;
	}
	p[ 128 ] = 0x00;
}

MTTERMEX BOOL WINAPI ClasterInitialize( char* iContext, char* iSymbol, int iDigits, int iSpread, double iPoint ) {
#if NDEBUG
	try {
#endif
		Context^ context = Global::Context->Append( (IntPtr)iContext );
		if ( context->Claster == nullptr ) {
			Claster^ claster = Global::Claster->Append( context, gcnew String( iSymbol ), iDigits, iSpread, iPoint );
		}
		iContext[ 0 ] = 0x00;
		Global::WindowControl();
		return TRUE;
#if NDEBUG
	} catch( Exception^ ) {
		return FALSE;
	}
#endif
}

MTTERMEX BOOL WINAPI ClasterUpdate( char* iContext, double iBid, unsigned int iSrv ) {
#if NDEBUG
	try {
#endif
		Context^ context = Global::Context[ (IntPtr)iContext ];
		if ( context->Claster == nullptr ) return FALSE;
		if ( context->Claster->Session->First->Context != context ) return FALSE;
		context->Claster->Ticks->AddValue( DateTime::UtcNow, iBid, (gcnew DateTime( 1970, 1, 1 ))->AddSeconds( iSrv ) );
		return TRUE;
#if NDEBUG
	} catch( Exception^ ) {
		return FALSE;
	}
#endif
}

MTTERMEX BOOL WINAPI ClasterFinalize( char* iContext ) {
#if NDEBUG
	try {
#endif
		Global::Context[ (IntPtr)iContext ]->Claster->Ticks->AddSpace( DateTime::UtcNow );
		Global::Context->Remove( (IntPtr)iContext );
		ZeroString128( iContext );
		Global::WindowControl();
		return TRUE;
#if NDEBUG
	} catch( Exception^ ) {
		return FALSE;
	}
#endif
}