using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MetaTrader.Windows {
	public partial class FormClasterProperties: Form {
	
		private Claster mClaster;
		private Form mForm;
		
		public Claster Claster {
			get {
				return mClaster;
			}
		}
	
		public FormClasterProperties( Claster iClaster, Form iForm ) {
			mClaster = iClaster;
			mForm = iForm;
			InitializeComponent();
			Text = iClaster.Symbol + " Properties";
			CreateProperties();
		}

		private void FormClasterProperties_Load( object sender, EventArgs e ) {

		}

		private void ButtonAccept_Click( object sender, EventArgs e ) {
			UpdateProperties();
			this.Close();
		}

		private void ButtonApply_Click( object sender, EventArgs e ) {
			UpdateProperties();
		}

		private void ButtonCancel_Click( object sender, EventArgs e ) {
			
		}
		
		public void CreateProperties() {
			DiagramTickHeight.Value = Claster.DiagramTickHeight;
			DiagramTickWidth.Value = Claster.DiagramTickWidth;
		}
		
		public void UpdateProperties() {
			Claster.DiagramTickHeight = (int)DiagramTickHeight.Value;
			Claster.DiagramTickWidth = (int)DiagramTickWidth.Value;
			if ( mForm is FormDiagram ) {
				( (FormDiagram)mForm ).ResetRedrawContent();
			}
		}
	}
}